Name:               Zope
Version:            2.1.4
Release:            2mdk
Copyright:          Zope Public License (ZPL)
URL:                http://www.zope.org/
BuildRoot:          /var/tmp/Zope-%{version}-rootdir
Prereq:             python python-devel /sbin/chkconfig /usr/sbin/useradd

Source0: http://www.zope.org/Download/Releases/Zope-%{version}/Zope-%{version}-src.tar.bz2
Source1: http://www.zope.org/Documentation/Guides/ZCMG/ZCMG.html.tar.bz2
Source2: http://www.zope.org/Documentation/Guides/DTML/DTML.html.tar.bz2
Source3: http://www.zope.org/Documentation/Guides/ZSQL/ZSQL.html.tar.bz2
Source4: http://www.zope.org/Documentation/Guides/Zope-ProductTutorial.tar.bz2
Source5: Zope-%{version}-zope
Source6: Zope-%{version}-Zope.cgi
Source7: Zope-%{version}-README.RPM
Source8: Zope-%{version}-zserver-wo-pcgi.sh
Source9: Zope-%{version}-zserver-w-pcgi.sh
Source10: http://www.zope.org/Documentation/Guides/ZDG/ZDG.html.tar.bz2
Source11: http://www.zope.org/Documentation/Guides/ZAG/ZAG.html.tar.bz2
Source12: Zope-%{version}-pcgi_nullpublisher.py
Source13: SiteAccess-0.2.0-nonbin.tar.bz2
Source14: Zope-%{version}-index.html

Patch0: Zope-2.1.4-rh61-syslog.patch.bz2
Patch1: Zope-2.1.4-syslog-msg-format.patch.bz2
Patch2: Zope-2.1.4-medusa-syslog.patch.bz2
Patch3: Zope-2.1.4-pcgi-syslog.patch.bz2

#----------------------------------------------------------------------
Summary:            An application server and portal toolkit for building Web sites.
Group:              System/Servers
Requires:           python >= 1.5.2

%description
The Z Object Programming Environment (Zope) is a free, Open Source[tm]
Python-based application server for building high-performance, dynamic
web sites, using a powerful and simple scripting object model and
high-performance, integrated object database.

Brian Lloyd's excellent article, An Introduction to Zope
(http://www.devshed.com/Server_Side/Zope/Intro/) provides a great starting
point to understanding what Zope is and how you can use it.

For a fully functional installation of Zope, install this single huge
package and then _either_ the Zope-zserver RPM, for a minimal Python-based
web server; or the Zope-pcgi RPM, for use with Apache's CGI facility.

If you only want portions of Zope, there are subpackages available
for each subsystem and you should _not_ install this RPM.

#----------------------------------------------------------------------
%package core
Summary:            Central Core of Zope w/General Extensions
Group:              System/Servers
Requires:           python >= 1.5.2, Zope-components, Zope-ztemplates, Zope-zpublisher, Zope-services
Provides:           					Zope

%description core
The Z Object Programming Environment (Zope) is a free, Open Source[tm]
Python-based application server for building high-performance, dynamic
web sites, using a powerful and simple scripting object model and
high-performance, integrated object database.

Brian Lloyd's excellent article, An Introduction to Zope
(http://www.devshed.com/Server_Side/Zope/Intro/) provides a great starting
point to understanding what Zope is and how you can use it.

The Zope-core package contains the central core programs and general
extensions needed to run Zope.

For a fully functional installation of Zope, install Zope, Zope-components,
Zope-core, Zope-services, Zope-zpublisher, and Zope-ztemplates, and one of
the following packages: Zope-zserver, for a minimal Python-based Web
server; or Zope-pcgi, for using Zope with Apache's CGI facility.

#----------------------------------------------------------------------
%package components
Summary:            A group of standalone Python binary extension modules.
Group:              System/Libraries
Requires:           python >= 1.5.2

%description components
The Zope-components package includes a group of standalone Python extension
modules, including BTree, cPickle/cStringIO, ExtensionClass, Acquisition,
MethodObject, MultiMapping, ThreadLock, Missing, Sync, Record,
ComputedAttribute and zlib.  These modules can be used with the Zope
application server and portal toolkit or standalone.

#----------------------------------------------------------------------
%package ztemplates
Summary:            A template for creating dynamic HTML for Zope.
Group:              System/Libraries
Requires:           python >= 1.5.2

%description ztemplates
The Zope-ztemplates package contains a Python-based template mechanism for
creating dynamic HTML sources, with Python expressions, looping constructs,
etc. The Z Template system can be used with the Zope application server and
portal tookit, or it can be used standalone. Z Template was called
DocumentTemplate in the olden days (before Zope).

#----------------------------------------------------------------------
%package zpublisher
Summary:            An object publishing mechanism for Zope.
Group:              System/Libraries
Requires:           python >= 1.5.2, Zope-components >= 2.0

%description zpublisher
Zpublisher is a Python-based object publishing mechanism that maps URLs
to an object hierarchy and handles the interface between the Web server
and the Web application, hiding many complex details.  Zpublisher is
used with the Zope application server and portal toolkit, but it can be
used standalone as well.  Zpublisher was called Bobo before Zope came along.


#----------------------------------------------------------------------
%package services
Summary:            Middle-level services for Zope.
Group:              System/Libraries
Requires:           python >= 1.5.2, Zope-components >= 2.0

%description services
The Zope-services package contains a group of middle-level services needed
by the Zope application server and portal toolkit (but not specifically
tied to Zope). Services included are DateTime, SearchIndex and
StructuredText.


#----------------------------------------------------------------------
%package zserver
Summary:            Initial Object Database/Standalone HTTP Server
Group:              System/Servers
Requires:           Zope
Conflicts:          Zope-pcgi
Provides:						Zope-webserver

%description zserver
The Zope-zserver package contains the files needed for setting up a
Zope website, including an empty object database. Zope is an application
server and portal toolkit.

Also included is the ZServer, which is a small, standalone web server
written in Python.  The ZServer uses the very fast Medusa technology
and is multithreaded.  This package comes preconfigured to serve
web pages on port 8080 and ftp access on 8021.  The programmer's port
interface comes disabled for security reasons but can be reenabled.

If you wish to instead run Zope thru Apache, do not use this package
but rather the Zope-pcgi package.  This package is for -standalone-
web serving.

#----------------------------------------------------------------------
%package pcgi
Summary:            Persistent CGI (PCGI) capabilities for Zope.
Group:              System/Servers
Requires:           Zope, apache >= 1.3
Conflicts:          Zope-zserver
URL:                http://starship.python.net/crew/jbauer/persistcgi/
Provides:						Zope-webserver
%description pcgi
Persistent CGI (PCGI) is an architecture designed by Digital Creations
(http://www.digicool.com) for publishing Web objects as long-running
server processes in order to improve the performance of serving Web
pages.  This package is PCGI for use with the Zope application server
and portal toolkit.

It is not necessary for ZServer to actually listen for incoming HTTP
requests.  If you want Apache to do the actual listening and serving,
then you can use ZServer's PCGI component to communicate with Apache.

Please note that versions of the Apache Web server prior to 1.3 do not
have a sufficiently implemented rewrite module to provide authentication
for Zope.  You'll need to upgrade your Apache if you're using a version
prior to 1.3.

For PCGI HOWTO information, see:
    http://starship.python.net/crew/jbauer/persistcgi/

%prep
# Create Build Subdirectory and Unpack the Main Tar Ball
%setup -q -n %{name}-%{version}-src

%setup -q -T -D -c -a 1 -n %{name}-%{version}-src/ZopeContentManagersGuide
%setup -q -T -D -c -a 2 -n %{name}-%{version}-src/GuideToDTML
%setup -q -T -D -c -a 3 -n %{name}-%{version}-src/GuideToZSQL
%setup -q -T -D -c -a 10 -n %{name}-%{version}-src/ZopeDevelopersGuide
%setup -q -T -D -c -a 11 -n %{name}-%{version}-src/ZopeAdminGuide
%setup -q -T -D -c -a 13 -n %{name}-%{version}-src

%setup -q -T -D    -a 4 -n %{name}-%{version}-src

# Reset RPM's Concept of "-n" Back to the Top-Level Package Dir Name
%setup -q -T -D -n %{name}-%{version}-src

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

# Create a Temporary Holding Area in the RPM's Build Directory for Docs
mkdir misc

# Some of the docs incorrectly have the 'Execute' bit set on their files
# so we do this for security reasons (and we can't use chmod -R if we
# want to only change files modes and not those of subdirectories) ;-(
find ZopeContentManagersGuide -type f -exec chmod 644 \{\} \;
find GuideToDTML              -type f -exec chmod 644 \{\} \;
find GuideToZSQL              -type f -exec chmod 644 \{\} \;
find Tutorial                 -type f -exec chmod 644 \{\} \;

####
# Section: Build Script (Actually Perform the Build; Usually Just 'make')
####
%build
  cp %{SOURCE7} $RPM_BUILD_DIR/%{name}-%{version}-src/README.RPM

  echo Building the PCGI Wrapper...
  (cd pcgi
  ./configure --prefix=/usr
  make)

  echo Building Extension Modules...

  # Set up an easily-accessible Makefile template
  cp lib/python/Shared/DC/xml/pyexpat/Makefile.pre.in  Makefile.pre.in

  cp Makefile.pre.in lib/Components/BTree
  cp Makefile.pre.in lib/Components/ExtensionClass
  cp Makefile.pre.in lib/Components/cPickle
  cp Makefile.pre.in lib/Components/zlib

  cp Makefile.pre.in lib/python/DocumentTemplate
  cp Makefile.pre.in lib/python/SearchIndex
  cp Makefile.pre.in lib/python/ZODB

  # === General Loadable-Binary-Library Python Components ===

  # BTree.so IIBTree.so IOBTree.so OIBTree.so intSet.so
  (cd lib/Components/BTree
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make CFLAGS="-I../../python/ZODB/ -I/usr/include/python1.5/"
   make clean
  )

  # ExtensionClass.so Acquisition.so MethodObject.so MultiMapping.so
  # ThreadLock.so Missing.so Sync.so Record.so ComputedAttribute.so
  (cd lib/Components/ExtensionClass
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   mkdir ExtensionClass
   mv test_*.py release.* ExtensionClass
   mv COPYRIGHT.txt ExtensionClass.COPYRIGHT.txt
   mv README ExtensionClass.README
  )

  # cStringIO.so cPickle.so
  (cd lib/Components/cPickle
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
  )

  # zlib.so
  (cd lib/Components/zlib
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
  )

  # pyexpat.so
  (cd lib/python/Shared/DC/xml/pyexpat
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   rm -rf expat
   mv README   $RPM_BUILD_DIR/%{name}-%{version}-src/misc/pyexpat.README
   find . -type f -not -name '*.py' -not -name '*.so' -exec rm \{\} \;
  )

  # === Zope Subsystems ===

  # cDocumentTemplate.so
  (cd lib/python/DocumentTemplate
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   find . -type f -not -name '*.py' -not -name '*.so' -not -name '*.stx' -exec rm \{\} \;
  )

  # TimeStamp.so cPersistence.so cPickleCache.so winlock.so coptimizations.so
  (cd lib/python/ZODB
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   find . -type f -not -name '*.py' -not -name '*.so' -not -name '*.gif' -not -name '*.html' -not -name '*.stx' -exec rm \{\} \;
  )

  # Splitter.so Query.so
  (cd lib/python/SearchIndex
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   find . -type f -not -name '*.py' -not -name '*.so' -exec rm \{\} \;
  )

  # Remove Non-Release Items Before Copying Dirs
  # into Package, to Minimize Package Size

  find lib/python -type f -and \( -name 'Setup' -or -name '.cvsignore' \) -exec rm \{\} \;
  rm ZServer/medusa/monitor_client_win32.py

####
# Section: Install-After-Build Script (Often Just 'make install')
####
%install
  rm -rf $RPM_BUILD_ROOT

  # Make the Necessary Directories
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages
  install -m0755 --directory      $RPM_BUILD_ROOT/home/httpd/html/zopedocs

  # Directory Structure for SOFTWARE_HOME=/usr/share/zope/
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/bin
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/share/zope
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/share/zope/import
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/share/zope/lib
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/share/zope/lib/python
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/share/zope/Extensions
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload

  # Directory Structure for INSTANCE_HOME=/var/zope/
  install -m0755 --directory      $RPM_BUILD_ROOT/etc/rc.d/init.d
  install -m0775 --directory      $RPM_BUILD_ROOT/var/zope
  install -m0775 --directory      $RPM_BUILD_ROOT/var/zope/Extensions
  install -m0711 --directory      $RPM_BUILD_ROOT/var/zope/var
  install -m0775 --directory      $RPM_BUILD_ROOT/var/zope/Products
  install -m0775 --directory      $RPM_BUILD_ROOT/var/log

  (cd lib/Components
   install -m0644 ExtensionClass/*.py  $RPM_BUILD_ROOT/usr/lib/python1.5/
   install -s     BTree/*.so           $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload/
   install -s     ExtensionClass/*.so  $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload/
   install -s     cPickle/*.so         $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload/
   install -s     zlib/zlib.so         $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload/
  )

  install                              $RPM_SOURCE_DIR/%{name}-%{version}-index.html \
                                       $RPM_BUILD_ROOT/home/httpd/html/zopedocs/index.html

  cp    lib/python/Products/ZCatalog/ZCatalog.txt \
                                       $RPM_BUILD_ROOT/home/httpd/html/zopedocs/

  cp -a ZopeContentManagersGuide/      $RPM_BUILD_ROOT/home/httpd/html/zopedocs/
  cp -a GuideToZSQL/                   $RPM_BUILD_ROOT/home/httpd/html/zopedocs/
  cp -a GuideToDTML/                   $RPM_BUILD_ROOT/home/httpd/html/zopedocs/
  cp -a Tutorial/                      $RPM_BUILD_ROOT/home/httpd/html/zopedocs/
  cp -a ZopeDevelopersGuide/           $RPM_BUILD_ROOT/home/httpd/html/zopedocs/
  cp -a ZopeAdminGuide/                $RPM_BUILD_ROOT/home/httpd/html/zopedocs/

  cp -a ZServer/                       $RPM_BUILD_ROOT/usr/share/zope/
  cp -a utilities/                     $RPM_BUILD_ROOT/usr/share/zope/
  install -m 0755 zpasswd.py           $RPM_BUILD_ROOT/usr/bin/zpasswd

  (cd lib/python
   # These are generally useful modules, (relatively) independent of Zope
   for i in DocumentTemplate/ SearchIndex/ ZPublisher/ DateTime/ \
            StructuredText/
   do
      cp -a $i $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/
   done

   # These are integral parts of Zope and can't really stand alone
   cp    version.txt                   $RPM_BUILD_ROOT/usr/share/zope/lib/python/

   for i in Zope/ AccessControl/ App/ HelpSys/ OFS/ TreeDisplay/ \
            ZClasses/ Shared/ Products/ ZODB/ webdav/ 
   do 
      cp -a $i $RPM_BUILD_ROOT/usr/share/zope/lib/python/
   done

   install -m0644 *.py                 $RPM_BUILD_ROOT/usr/share/zope/lib/python/
  )

  # Give ZODB the -particular- version of cPickle that ships with Zope
  install -s lib/Components/cPickle/cPickle.so $RPM_BUILD_ROOT/usr/share/zope/lib/python/ZODB/

  install -m 0755 -s pcgi/pcgi-wrapper  $RPM_BUILD_ROOT/usr/bin/pcgi-wrapper
  install pcgi/pcgi_publisher.py        $RPM_BUILD_ROOT/usr/lib/python1.5/pcgi_publisher.py
  install pcgi/Util/killpcgi.py         $RPM_BUILD_ROOT/usr/lib/python1.5/killpcgi.py

  install                               $RPM_SOURCE_DIR/%{name}-%{version}-pcgi_nullpublisher.py  \
                                        $RPM_BUILD_ROOT/var/zope/pcgi_nullpublisher.py

  # Establish an Empty Zope Object Database
  install -m 0600 var/Data.fs.in        $RPM_BUILD_ROOT/var/zope/var/Data.fs

  # Create a Safe Preowned Zope Logfile, for ZServer
  # (Otherwise a symlink-redirect attack may be possible!)
  touch $RPM_BUILD_ROOT/var/log/zope

  # Declare the Superuser of the Default Zope Project
  python $RPM_BUILD_ROOT/usr/bin/zpasswd -u superuser -p 123 -d localhost $RPM_BUILD_ROOT/var/zope/access
  chmod 0600 $RPM_BUILD_ROOT/var/zope/access

  install -m 0755 %{SOURCE5} $RPM_BUILD_ROOT/etc/rc.d/init.d/zope
  install -m 0755 %{SOURCE6} $RPM_BUILD_ROOT/var/zope/Zope.cgi
  install -m 0755 %{SOURCE8} $RPM_BUILD_ROOT/var/zope/zserver_wo_pcgi.sh
  install -m 0755 %{SOURCE9} $RPM_BUILD_ROOT/var/zope/zserver_w_pcgi.sh
  install -m 0755 z2.py      $RPM_BUILD_ROOT/var/zope/z2.py

  # Precompile Python Source for Faster Imports During Usage
  # (Since user of package may not have write-access to install directory)
  python -O /usr/lib/python1.5/compileall.py    -d /usr/lib/python1.5/  $RPM_BUILD_ROOT/usr/lib/python1.5
  python    /usr/lib/python1.5/compileall.py    -d /usr/lib/python1.5/  $RPM_BUILD_ROOT/usr/lib/python1.5

  python -O /usr/lib/python1.5/compileall.py    -d /usr/share/zope/     $RPM_BUILD_ROOT/usr/share/zope
  python    /usr/lib/python1.5/compileall.py    -d /usr/share/zope/     $RPM_BUILD_ROOT/usr/share/zope

  # Remove Duplicate Documentation Embedded in Python Package Dirs
  (cd $RPM_BUILD_ROOT/usr/share/zope
   rm     lib/python/AccessControl/AccessControl.txt
   rm     lib/python/Products/ZCatalog/ZCatalog.txt
   rm     ZServer/{INSTALL,README}.txt
  )
  (cd $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages
   rm     DateTime/DateTime.html
   rm     DocumentTemplate/Let.stx
   rm -rf StructuredText/regressions/
  )

####
# Section: Delivery Install/Uninstall Scripts (Pre/Post Install/Erase Scripts)
####

%pre zserver
  /usr/sbin/useradd -o -r -M -s /bin/bash -d /var/zope -c "Zope Server" zope >/dev/null 2>&1

%pre pcgi
  /usr/sbin/useradd -o -r -M -s /bin/bash -d /var/zope -c "Zope Server" zope >/dev/null 2>&1

%post zserver
  /sbin/chkconfig --add zope
  ln -sf /var/zope/zserver_wo_pcgi.sh /var/zope/zserver.sh
  ln -sf /usr/share/zope/import /var/zope/import

%post pcgi
  /sbin/chkconfig --add zope
  ln -sf /var/zope/zserver_w_pcgi.sh /var/zope/zserver.sh
  ln -sf /usr/share/zope/import /var/zope/import

%preun zserver
  if [ "$1" = 0 ] ; then
    if [ /var/zope/zserver_wo_pcgi.sh -ef /var/zope/zserver.sh ]; then
      rm /var/zope/zserver.sh
    fi
    if [ /usr/share/zope/import -ef /var/zope/import ]; then
      rm /var/zope/import
    fi
    /sbin/chkconfig --del zope
  fi

%preun pcgi
  if [ "$1" = 0 ] ; then
    if [ /var/zope/zserver_w_pcgi.sh -ef /var/zope/zserver.sh ]; then
      rm /var/zope/zserver.sh
    fi
    if [ /usr/share/zope/import -ef /var/zope/import ]; then
      rm /var/zope/import
    fi
    /sbin/chkconfig --del zope
  fi

%postun zserver
  if [ $1 = 0 ] ; then
	userdel zope >/dev/null 2>&1 || :
  fi

%postun pcgi
  if [ $1 = 0 ] ; then
	userdel zope >/dev/null 2>&1 || :
  fi

####
# Section: Verify Script (Check for Proper Installation of Package)
####

%verifyscript zserver
  if [ ! /var/zope/zserver_wo_pcgi.sh -ef /var/zope/zserver.sh ]; then
    echo "/var/zope/zserver_wo_pcgi.sh should be linked to /var/zope/zserver.sh" >&2
  fi

  if [ ! /usr/share/zope/import -ef /var/zope/import ]; then
    echo "/usr/share/zope/import should be linked to /var/zope/import" >&2
  fi

%verifyscript pcgi
  if [ ! /var/zope/zserver_w_pcgi.sh -ef /var/zope/zserver.sh ]; then
    echo "/var/zope/zserver_w_pcgi.sh should be linked to /var/zope/zserver.sh" >&2
  fi

  if [ ! /usr/share/zope/import -ef /var/zope/import ]; then
    echo "/usr/share/zope/import should be linked to /var/zope/import" >&2
  fi

####
# Section: Clean Script (Tidy Up Build Area After a Build Completes)
####
%clean
  rm -rf $RPM_BUILD_ROOT

####
# Section: Files (List of Files w/Attributes Making Up Package)
####

# Note: the root package of just Zope (w/o any -<stuff>) includes all
#       of the Zope release, for those who want to quickly install
#       everything.  The release is also packaged as separate subpackages
#       for those who want to be more selective.

%files
  %defattr(-, root, root)

  #-- Copy of Zope-core Contents:
  %doc LICENSE.txt README.txt README.RPM

  # User's Guides
  %doc /home/httpd/html/zopedocs/index.html
  %doc /home/httpd/html/zopedocs/ZopeContentManagersGuide
  %doc /home/httpd/html/zopedocs/GuideToZSQL
  %doc /home/httpd/html/zopedocs/Tutorial
  %doc /home/httpd/html/zopedocs/ZopeDevelopersGuide
  %doc /home/httpd/html/zopedocs/ZopeAdminGuide
  %doc /home/httpd/html/zopedocs/ZCatalog.txt
  %doc doc/
  %doc lib/python/AccessControl/AccessControl.txt
  %doc misc/pyexpat.README

  # ZOPE-Specific Python Packages
  /usr/share/zope/lib/python/

  %dir /usr/share/zope/Extensions
  /usr/bin/zpasswd

  #-- Copy of Zope-components Contents:
  %doc lib/Components/ExtensionClass/ExtensionClass/
  %doc lib/Components/ExtensionClass/*.stx
  %doc lib/Components/cPickle/cPickle.stx
  %doc lib/Components/ExtensionClass/ExtensionClass.README
  %doc lib/Components/ExtensionClass/ExtensionClass.COPYRIGHT.txt

  # BTree Module(s):
  /usr/lib/python1.5/lib-dynload/BTree.so
  /usr/lib/python1.5/lib-dynload/IIBTree.so
  /usr/lib/python1.5/lib-dynload/IOBTree.so
  /usr/lib/python1.5/lib-dynload/OIBTree.so
  /usr/lib/python1.5/lib-dynload/intSet.so

  # ExtensionClass Module(s):
  /usr/lib/python1.5/lib-dynload/Acquisition.so
  /usr/lib/python1.5/lib-dynload/ComputedAttribute.so
  /usr/lib/python1.5/lib-dynload/ExtensionClass.so
  /usr/lib/python1.5/lib-dynload/MethodObject.so
  /usr/lib/python1.5/lib-dynload/Missing.so
  /usr/lib/python1.5/lib-dynload/MultiMapping.so
  /usr/lib/python1.5/lib-dynload/Record.so
  /usr/lib/python1.5/lib-dynload/Sync.so
  /usr/lib/python1.5/lib-dynload/ThreadLock.so
  /usr/lib/python1.5/ComputedAttribute.py
  /usr/lib/python1.5/Xaq.py

  # zlib Module(s):
  #  /usr/lib/python1.5/lib-dynload/zlib.so

  # cPickle Module(s):
  # We omit cStringIO from the package, because it ships with the Python
  # RPM itself, in the Red Hat 5.1/5.2 distribution.  If we did include
  # it, it would conflict.  What to do?
  %doc lib/Components/cPickle/cPickle.stx
  # /usr/lib/python1.5/lib-dynload/cStringIO.so

  #-- Copy of Zope-zpublisher Contents:
  /usr/lib/python1.5/site-packages/ZPublisher/

  #-- Copy of Zope-ztemplates Contents:
  %doc lib/python/DocumentTemplate/Let.stx
  %doc /home/httpd/html/zopedocs/GuideToDTML
  /usr/lib/python1.5/site-packages/DocumentTemplate/

  #-- Copy of Zope-services Contents:
  %doc lib/python/DateTime/DateTime.html
  %doc lib/python/StructuredText/regressions/
  /usr/lib/python1.5/site-packages/DateTime/
  /usr/lib/python1.5/site-packages/StructuredText/
  /usr/lib/python1.5/site-packages/SearchIndex/

%files core
  %defattr(-, root, root)
  %doc LICENSE.txt README.txt README.RPM

  # User's Guides
  %doc /home/httpd/html/zopedocs/index.html
  %doc /home/httpd/html/zopedocs/ZopeContentManagersGuide
  %doc /home/httpd/html/zopedocs/GuideToZSQL
  %doc /home/httpd/html/zopedocs/Tutorial
  %doc /home/httpd/html/zopedocs/ZopeDevelopersGuide
  %doc /home/httpd/html/zopedocs/ZopeAdminGuide
  %doc /home/httpd/html/zopedocs/ZCatalog.txt
  %doc doc/
  %doc lib/python/AccessControl/AccessControl.txt
  %doc misc/pyexpat.README

  # ZOPE-Specific Python Packages
  /usr/share/zope/lib/python/

  %dir /usr/share/zope/Extensions
  /usr/bin/zpasswd

%files components
  %defattr(-, root, root)
  %doc LICENSE.txt
  %doc lib/Components/ExtensionClass/ExtensionClass/
  %doc lib/Components/ExtensionClass/*.stx
  %doc lib/Components/cPickle/cPickle.stx
  %doc lib/Components/ExtensionClass/ExtensionClass.README
  %doc lib/Components/ExtensionClass/ExtensionClass.COPYRIGHT.txt

  # BTree Module(s):
  /usr/lib/python1.5/lib-dynload/BTree.so
  /usr/lib/python1.5/lib-dynload/IIBTree.so
  /usr/lib/python1.5/lib-dynload/IOBTree.so
  /usr/lib/python1.5/lib-dynload/OIBTree.so
  /usr/lib/python1.5/lib-dynload/intSet.so

  # ExtensionClass Module(s):
  /usr/lib/python1.5/lib-dynload/Acquisition.so
  /usr/lib/python1.5/lib-dynload/ComputedAttribute.so
  /usr/lib/python1.5/lib-dynload/ExtensionClass.so
  /usr/lib/python1.5/lib-dynload/MethodObject.so
  /usr/lib/python1.5/lib-dynload/Missing.so
  /usr/lib/python1.5/lib-dynload/MultiMapping.so
  /usr/lib/python1.5/lib-dynload/Record.so
  /usr/lib/python1.5/lib-dynload/Sync.so
  /usr/lib/python1.5/lib-dynload/ThreadLock.so
  /usr/lib/python1.5/ComputedAttribute.py
  /usr/lib/python1.5/Xaq.py

  # zlib Module(s):
  #  /usr/lib/python1.5/lib-dynload/zlib.so

  # cPickle Module(s):
  # We omit cStringIO from the package, because it ships with the Python
  # RPM itself, in the Red Hat 5.1/5.2 distribution.  If we did include
  # it, it would conflict.  What to do?
  %doc lib/Components/cPickle/cPickle.stx
  # /usr/lib/python1.5/lib-dynload/cStringIO.so

%files zpublisher
  %defattr(-, root, root)
  %doc LICENSE.txt
  /usr/lib/python1.5/site-packages/ZPublisher/

%files ztemplates
  %defattr(-, root, root)
  %doc LICENSE.txt  lib/python/DocumentTemplate/Let.stx
  %doc /home/httpd/html/zopedocs/GuideToDTML
  /usr/lib/python1.5/site-packages/DocumentTemplate/

%files services
  %defattr(-, root, root)
  %doc LICENSE.txt  lib/python/DateTime/DateTime.html
  %doc lib/python/StructuredText/regressions/
  /usr/lib/python1.5/site-packages/DateTime/
  /usr/lib/python1.5/site-packages/StructuredText/
  /usr/lib/python1.5/site-packages/SearchIndex/

%files zserver
  %defattr(-, root, root)
  %doc LICENSE.txt  ZServer/INSTALL.txt  ZServer/README.txt
  /usr/share/zope/ZServer/
  /usr/share/zope/utilities/
  /usr/share/zope/import/

  %config                             /etc/rc.d/init.d/zope
  %config(noreplace) %attr(600, root, root)      /var/zope/access
  %config                             /var/zope/z2.py
  %config                             /var/zope/zserver_wo_pcgi.sh

  # IMPORTANT: ZServer runs as user 'zope' and
  #            must have r/w access to the var/ directory
  #            so that it can create temp and index files.
  %defattr(-, zope, root)
  %dir                                /var/zope/
  %dir                                /var/zope/Products
  %dir                                /var/zope/Extensions
  %dir                                /var/zope/var/
  %config(noreplace) %verify(not size md5 mtime) /var/zope/var/Data.fs
  %verify(not size md5 mtime)         /var/log/zope

%files pcgi
  %defattr(-, root, root)
  %doc LICENSE.txt  pcgi/README  ZServer/README.txt  ZServer/INSTALL.txt
  %doc pcgi/Example/  pcgi/Test/  pcgi/Util/

  /usr/bin/pcgi-wrapper
  /usr/lib/python1.5/pcgi_publisher.py
  /var/zope/pcgi_nullpublisher.py
  /usr/lib/python1.5/killpcgi.py
  /usr/share/zope/ZServer/
  /usr/share/zope/utilities/
  /usr/share/zope/import/

  %config                             /etc/rc.d/init.d/zope
  %config(noreplace) %attr(600, root, root) /var/zope/access
  %config                             /var/zope/z2.py
  %config                             /var/zope/zserver_w_pcgi.sh
                                      /var/zope/Zope.cgi

  # IMPORTANT: PCGI runs as user 'zope' and must have r/w
  #            access to the var/ directory so that it can
  #            create temp and index files.  ZServer runs as
  #            user 'zope' and must have write access to var.
  %defattr(-, zope, root)
  %dir                                /var/zope/
  %dir                                /var/zope/Products
  %dir                                /var/zope/Extensions
  %dir                                /var/zope/var/
  %config(noreplace) %verify(not size md5 mtime) /var/zope/var/Data.fs
  %verify(not size md5 mtime)         /var/log/zope

%changelog
* Sun Apr 02 2000 John Buswell <johnb@mandrakesoft.com> 2.1.4-2mdk
- Removed vendor tag

* Fri Mar 31 2000 John Buswell <johnb@mandrakesoft.com> 2.1.4-1mdk
- Initial Mandrake Release
- fixed groups
- spec-helper

* Thu Feb 26 2000 Jeff Rush <jrush@taupro.com>
- bumped to zope 2.1.4
- changed Zope-core to provide 'Zope', to satisfy zserver and pcgi subpkgs.

* Fri Jan 14 2000 Tim Powers <timp@redhat.com>
- added Provides lines to Zope-pcgi and Zope-zserver so that addon packages
	such as Squishdot have something useful to require.

* Thu Jan 13 2000 Tim Powers <timp@redhat.com>
- built for Powertools 6.2

* Thu Jan 11 2000 Jeff Rush <jrush@taupro.com>
- bumped to zope 2.1.2
- folded in Jonathan Marsden <jonathan@xc.org> Changes (many below)
- used zpasswd.py to generate initial pw in encrypted form.
- fixed syslog logging in various ways, and re-enabled it, for both
-    ZServer AND pcgi-wrapper.
- fixed /etc/rc.d/init.d/zope to be consistent about pid file.
- fixed /etc/rc.d/init.d/zope to use RH killproc function.
- added 'noreplace' so that Zope database and access file are retained
-    on an RPM upgrade.
- patched PCGI to support syslog logging, and then default to it.
- patched ZServer/Medusa to properly support syslog logging.
- added a user 'zope' and made many zope files/dirs owned by it.
- cleaned up pcgi-wrapper's msg about can't find ZServer, since it is
-    one of the most common errors.  It now explains what it is doing.
- moved all *.{pid,soc} files into /var/run, to cleanly separate ownership
-    issues in /var/zope hierarchy for user 'zope' and user 'nobody'.

* Mon Jan 03 2000 Jeff Rush <jrush@taupro.com>
- bumped to zope 2.1.1
- added to /etc/rc.d/init.d/zope code to correctly kill the process specified
-    in /var/zope/pcgi.pid
- changed permissions on /var/zope/access such that only root can read/write
-    it, to protect the Zope superuser password.

* Sat Nov 29 1999 Jeff Rush <jrush@taupro.com>
- changed ownership on /var/zope/access from nobody.nobody to root.root.

* Sat Nov 20 1999 Jeff Rush <jrush@taupro.com>
- updated to zope 2.1.0beta2
- fixed permissions/ownership on /var/zope/access to be more secure (600).
- removed pypath.patch, as those changes got into the zope distribution.

* Tue Nov 2 1999 Jeff Rush <jrush@taupro.com>
- added accidentally omitted /usr/bin/zpasswd to the RPM output.
- clarified wording re use of zpasswd in README.RPM file.
- added "-u nobody" to both zserver_*.sh files, for clarity of intent;
-    it already ran as nobody by default, but some people worried.

* Wed Oct 27 1999 Jeff Rush <jrush@taupro.com>
- fixed /etc/rc.d/init.d/zope file to *NOT* delete /var/zope/zserver.pid
- fixed /var/zope/Zope.cgi to use PCGI_PUBLISHER=/var/zope/pcgi_nullpublisher.py,
-    so that when the PCGI wrapper can't find ZServer, it won't try to start one
-    and generate bogus error messages, because PCGI doesn't do it right.
- fixed /var/zope/zserver.sh to NOT specify syslog-style logging, since under
-    Red Hat 6.1, the syslog daemon no longer listens to the port we expected.

* Sat Sep 25 1999 Jeff Rush <jrush@taupro.com>
- updated documents ZCMG, ZSQL and ZDTML to Sep 24th 1999 versions
- added empty directories /var/zope/{import,Extensions}
- relocated zope from /usr/lib/python1.5/site-packages/ZopeWorld/
-    to /usr/share/zope/
- added user zope, for better security control

* Fri Sep 17 1999 Jeff Rush <jrush@taupro.com>
- updated sources to minor (security fix) release 2.0.1

* Fri Sep 10 1999 Jeff Rush <jrush@taupro.com>
- heavily reworked spec file for 2.0.0

* Thu Sep 9 1999 Tim Powers <timp@redhat.com>
- updated sources to 2.0.0
- _major_ spec file cleanups
- merged patch from src.rpm authored by Andreas Kostyrka <andreas@mtg.co.at>
- borrowed some things from Andreas Kostyrka's spec file

* Mon Aug 30 1999 Tim Powers <timp@redhat.com>
- changed groups

* Tue Aug 17 1999 Tim Powers <timp@redhat.com>
- chown permissions on some files in /var/local for the pcgi package

* Mon Aug 2 1999 Tim Powers <timp@redhat.com>
- changed buildroot to be in /var/tmp instead of /tmp
- rebuilt for 6.1

* Mon Jul 21 1999 Jeff Rush <jrush@taupro.com>
- Added in accidently omitted SearchIndex/{Query,Splitter}.so

* Tue Jul 6 1999 Tim Powers <timp@redhat.com>
- started changelog
- cleaned up spec file
- built for powertools

* Mon Jun 24 1999 Jeff Rush <jrush@taupro.com>
- Updated to 1.10.3

* Mon Jun 23 1999 Jeff Rush <jrush@taupro.com>
- Added /etc/rc.d/init.d/zope and reworked scripts

* Tue Mar 1 1999 Jeff Rush <jrush@taupro.com>
- Updated to 1.10.2

* Wed Jan 29 1999 Jeff Rush <jrush@taupro.com>
- Updated to 1.9.0 Final Release

* Wed Dec 9 1998 Jeff Rush <jrush@taupro.com>
- Original 1.9beta1 Release

